<script setup lang="ts">
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { type Salary } from '@/types/Salary'
import { useSalaryStore } from '@/stores/salary'

const form = ref(false)
const loading = ref(false)
const refForm = ref<VForm | null>(null)
const search = ref('')
const salarys = ref<Salary[]>([])
const dialog = ref(false)
const dialogDelete = ref(false)
const dialogPay = ref(false)
const dialogPayConfirm = ref(false)
const dialogSuccess = ref(false)
const dialogPrintSlip = ref(false)

const filteredSalary = computed(() => {
  return salaryStore.salarys.filter((salarys) =>
    salarys.employeeName.toUpperCase().includes(search.value.toUpperCase())
  )
})

const itemsPerPage = ref<any>(10)
const page = ref(1)
const pageCount = computed(() => {
  return Math.ceil(salarys.value.length / itemsPerPage.value)
})

const headersSalary = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Employee Name',
    key: 'employeeName',
    value: 'employeeName'
  },
  {
    title: 'Payment Date',
    key: 'payDate',
    value: 'payDate'
  },
  {
    title: 'Bank Account',
    key: 'bankAcc',
    value: 'bankAcc'
  },
  {
    title: 'Base Salary',
    key: 'baseSalary',
    value: (item: Salary) => item.baseSalary.toFixed(2)
  },
  {
    title: 'Increases',
    key: 'increasesalary',
    value: (item: Salary) => item.increaseSalary.toFixed(2)
  },
  {
    title: 'Deducted',
    key: 'salaryreduc',
    value: (item: Salary) => item.salaryReduc.toFixed(2)
  },
  {
    title: 'Net Salary',
    key: 'netSalary',
    value: (item: Salary) => item.netSalary.toFixed(2)
  },
  {
    title: 'Status',
    key: 'status',
    value: (item: any | Salary) => item.status
  },
  { title: '', key: 'actions', sortable: false }
]

const selected = ref()
const salaryStore = useSalaryStore()

// function createSelect() {
//   if (headersSalary.length > 0) {
//     selected.value = headersSalary[0]
//   }
// }
const currentDate: Date = new Date()

// function initialize() {
//   salarys.value = [
//     {
//       id: 1,
//       name: 'manager',
//       payDate: new Date(''),
//       bankAccount: '324-1-12345-9',
//       salary: 40000,
//       increasesalary: 0,
//       salaryreduction: 0,
//       netpayment: 0,
//       status: 'Pending',
//       roles: ['manager']
//     },
//     {
//       id: 2,
//       name: 'kanoknapas',
//       payDate: new Date('2024-01-02'),
//       bankAccount: '024-0-12545-9',
//       salary: 30000,
//       increasesalary: 500.0,
//       salaryreduction: 200.0,
//       netpayment: 0,
//       status: 'Paid',
//       roles: ['manager']
//     },
//     {
//       id: 3,
//       name: 'staff',
//       payDate: new Date(''),
//       bankAccount: '332-1-12315-0',
//       salary: 20000,
//       increasesalary: 0,
//       salaryreduction: 200.0,
//       netpayment: 0,
//       status: 'Pending',
//       roles: ['staff']
//     },
//     {
//       id: 4,
//       name: 'top',
//       payDate: new Date(''),
//       bankAccount: '054-8-02345-1',
//       salary: 20000,
//       increasesalary: 300.0,
//       salaryreduction: 0,
//       netpayment: 0,
//       status: 'Pending',
//       roles: ['staff']
//     },
//     {
//       id: 5,
//       name: 'staff3',
//       payDate: new Date(''),
//       bankAccount: '021-9-12245-8',
//       salary: 20000,
//       increasesalary: 200.0,
//       salaryreduction: 200.0,
//       netpayment: 0,
//       status: 'Pending',
//       roles: ['staff']
//     }
//   ]
// }

onMounted(async () => {
  await salaryStore.getSalarys()
})

function onSubmit() {}

async function editItem(item: Salary) {
  if (!item.id) return
  await salaryStore.getSalary(item.id)
  dialog.value = true
}

async function deleteItem(item: Salary) {
  if (!item.id) return
  await salaryStore.getSalary(item.id)
  dialogDelete.value = true
}

// function deleteItemConfirm() {
//     await salaryStore.
//   salarys.value.splice(editedIndex, 1)
//   closeDelete()
//   editedIndex = -1
// }

// function closeDelete() {
//   dialogDelete.value = false
//   nextTick(() => {
//     editedSalary.value = Object.assign({}, initialSalary)
//   })
// }

function closeDialog() {
  dialog.value = false
  dialogPayConfirm.value = false
  dialogPrintSlip.value = false

  nextTick(() => {
    salaryStore.clearForm()
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  await salaryStore.saveSalary()
  closeDialog()
}

async function paySalary(item: Salary) {
  if (!item.id) return
  await salaryStore.getSalary(item.id)
  dialogPay.value = true
  dialogPayConfirm.value = true
}

async function payConfirm() {
  salaryStore.editedSalary.status = 'Paid'
  salaryStore.editedSalary.payDate = new Date()
  await salaryStore.updatePayment()
  closeConfirm()
  successPay()
}

function closePay() {
  dialogPay.value = false
  nextTick(() => {
    salaryStore.clearForm()
  })
}

function successPay() {
  dialogSuccess.value = true
}

function closeConfirm() {
  dialogPayConfirm.value = false
}
async function printSlip(item: Salary) {
  if (!item.id) return
  await salaryStore.getSalary(item.id)
  selected.value = item
  if (item.status != 'Pending') {
    dialogPrintSlip.value = true
  }
}

function closePrintSlip() {
  dialogPrintSlip.value = false
  nextTick(() => {
    salaryStore.clearForm()
  })
}

function print() {
  dialogPrintSlip.value = false
}
</script>

<template>
  <div style="width: 95%; height: 100%; margin-top: 5%">
    <v-data-table-virtual
      v-model:page="page"
      :headers="headersSalary"
      :items="filteredSalary"
      :items-per-page="itemsPerPage"
    >
      <template v-slot:top>
        <v-toolbar flat color="#F48FB1">
          <v-toolbar-title>
            <v-icon icon="mdi-account-credit-card"></v-icon>
            Salary</v-toolbar-title
          >
          <v-divider class="mx-4" inset vertical></v-divider>

          <v-text-field
            v-model="search"
            prepend-inner-icon="mdi-magnify"
            density="compact"
            label="Search"
            single-line
            flat
            hide-details
            variant="outlined"
            style="margin-right: 20px"
          ></v-text-field>

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn class="mx-2" color="#ECEFF1" variant="flat" v-bind="props">
                <v-icon icon="mdi-plus"> </v-icon>
                Add Salary
              </v-btn>
            </template>

            <v-card>
              <v-card-title>
                <span class="text-h5">User Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="salaryStore.editedSalary.employeeId"
                          :readonly="loading"
                          :rules="[(v) => !/[^0-9]/g.test(v)]"
                          class="mb-2"
                          clearable
                          label="Employee ID"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="salaryStore.editedSalary.increaseSalary"
                          :readonly="loading"
                          :rules="[(v) => !/[^0-9]/g.test(v)]"
                          class="mb-2"
                          clearable
                          label="Increase Salary"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model.number="salaryStore.editedSalary.salaryReduc"
                          :readonly="loading"
                          :rules="[(v) => !/[^0-9]/g.test(v)]"
                          class="mb-2"
                          clearable
                          label="Salary Reduction"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>

                  <br />
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" @click="closeDialog()"> Close </v-btn>
                <v-btn color="green" variant="flat" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <br />
            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
            <br />
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" variant="flat" width="80px" @click="closeDelete">Cancel</v-btn>
              <v-btn color="green" variant="flat" width="80px" @click="deleteItemConfirm">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
            <br />
          </v-card>
        </v-dialog> -->

          <v-dialog v-model="dialogPayConfirm" max-width="500px">
            <v-card class="align align-center">
              <br />
              <v-card-title class="text-h5">Are you sure you want to confirm ?</v-card-title>
              <br />
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" width="80px" @click="closeConfirm">Cancel</v-btn>
                <v-btn color="green" variant="flat" width="80px" @click="payConfirm">Confirm</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
              <br />
            </v-card>
          </v-dialog>

          <v-dialog v-model="dialogPrintSlip" max-width="1000px">
            <v-card class="align-center">
              <br />
              <br />
              <v-sheet class="align-center" elevation="10" width="90%">
                <br />
                <v-spacer></v-spacer>
                <p style="text-align: center">-- Pay Slip --</p>
                <br />
                <v-card-text style="margin-left: 20px">
                  <p style="font-size: large">D Coffee</p>
                  <br />
                  <p>ID : {{ salaryStore.editedSalary.employeeId }}</p>
                  <p>Name : {{ salaryStore.editedSalary.employeeName }}</p>
                  <p>
                    Payment Date :
                    {{ salaryStore.editedSalary.payDate.toString().split('T')[0] }}
                  </p>
                </v-card-text>
                <v-card-text style="padding: 30px">
                  <v-table class="printTable">
                    <thead>
                      <tr>
                        <th>Earnings</th>
                        <th>Amount</th>
                        <th>Deductions</th>
                        <th>Amount</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr>
                        <td>Salary</td>
                        <td>{{ salaryStore.editedSalary.baseSalary.toFixed(2) }}</td>

                        <td>Decrease</td>
                        <td>{{ salaryStore.editedSalary.salaryReduc.toFixed(2) }}</td>
                      </tr>
                      <tr>
                        <td>Increases</td>
                        <td>{{ salaryStore.editedSalary.increaseSalary.toFixed(2) }}</td>
                        <td colspan="2"></td>
                      </tr>
                      <tr>
                        <td>Total Earnings</td>
                        <td>
                          {{
                            (
                              salaryStore.editedSalary.baseSalary +
                              salaryStore.editedSalary.increaseSalary
                            ).toFixed(2)
                          }}
                        </td>
                        <td>Total Deductions</td>
                        <td>{{ salaryStore.editedSalary.salaryReduc.toFixed(2) }}</td>
                      </tr>
                      <tr>
                        <td>Salary Amount :</td>
                        <td>
                          {{
                            (
                              salaryStore.editedSalary.baseSalary +
                              salaryStore.editedSalary.increaseSalary -
                              salaryStore.editedSalary.salaryReduc
                            ).toFixed(2)
                          }}
                        </td>
                      </tr>
                    </tbody>
                  </v-table>
                </v-card-text>
                <v-card-text style="margin-left: 20px">
                  <v-row>
                    <v-col>Remarks :</v-col>
                    <v-col>Employee's Signature : ________________________</v-col>
                  </v-row>
                </v-card-text>
                <br />
                <br />
              </v-sheet>
              <br />
              <v-card-actions>
                <v-btn
                  class="text-none mb-2"
                  color="red"
                  variant="flat"
                  width="80px"
                  @click="closePrintSlip()"
                  >Cancel</v-btn
                >
                <v-btn
                  class="text-none mb-2"
                  color="green"
                  variant="flat"
                  width="80px"
                  @click="print()"
                  >Print</v-btn
                >
              </v-card-actions>
              <br />
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <template v-slot:[`item.payDate`]="{ value }">
        {{
          value && !isNaN(new Date(value).getTime())
            ? new Date(value).toLocaleDateString('en-GB')
            : ''
        }}
      </template>

      <template v-slot:[`item.netSalary`]="{ item }">
        {{ salaryStore.calNetSalary(item) }}
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-menu>
          <template v-slot:activator="{ props }">
            <v-btn
              class="ma-1"
              color="green-lighten-2"
              size="x-small"
              variant="flat"
              elevation="2"
              @click="paySalary(item)"
            >
              Pay
            </v-btn>

            <v-btn
              v-bind="props"
              class="ma-1"
              color="grey-lighten-2"
              size="x-small"
              variant="flat"
              elevation="2"
            >
              <v-icon>mdi-dots-horizontal</v-icon>
            </v-btn>
          </template>

          <v-card>
            <v-list>
              <v-list-item @click="editItem(item)">
                <v-icon> mdi-pencil</v-icon>
                Edit
              </v-list-item>
              <v-list-item @click="printSlip(item)">
                <v-icon> mdi-receipt-text</v-icon>
                Print Slip
              </v-list-item>
              <v-list-item @click="deleteItem(item)">
                <v-icon> mdi-delete</v-icon>
                Delete
              </v-list-item>
            </v-list>
          </v-card>
        </v-menu>
      </template>
      <template v-slot:[`item.status`]="{ item }">
        <div class="text-start">
          <v-chip
            :color="item.status === 'Paid' ? 'green' : 'red'"
            class="text-uppercase"
            label
            size="small"
            >{{ item.status === 'Paid' ? 'Paid' : 'Pending' }}
          </v-chip>
        </div>
      </template>
      <template v-slot:bottom>
        <div class="text-center pt-2">
          <v-pagination v-model="page" :length="pageCount"></v-pagination>
        </div>
      </template>
    </v-data-table-virtual>
  </div>
</template>

<style scoped>
.printTable {
  border-collapse: collapse;
  border: 1px solid black;
}
</style>
